<!DOCTYPE html PUBLIC "-//W3C//DTD XHTML 1.0 Transitional//EN" "http://www.w3.org/TR/xhtml1/DTD/xhtml1-transitional.dtd">
<html xmlns="http://www.w3.org/1999/xhtml">
<head>
<meta http-equiv="Content-Type" content="text/xhtml;charset=UTF-8"/>
<meta http-equiv="X-UA-Compatible" content="IE=9"/>
<meta name="generator" content="Doxygen 1.8.12"/>
<meta name="viewport" content="width=device-width, initial-scale=1"/>
<title>eduRayTracer: RayTracer Class Reference</title>
<link href="tabs.css" rel="stylesheet" type="text/css"/>
<script type="text/javascript" src="jquery.js"></script>
<script type="text/javascript" src="dynsections.js"></script>
<link href="navtree.css" rel="stylesheet" type="text/css"/>
<script type="text/javascript" src="resize.js"></script>
<script type="text/javascript" src="navtreedata.js"></script>
<script type="text/javascript" src="navtree.js"></script>
<script type="text/javascript">
  $(document).ready(initResizable);
</script>
<link href="search/search.css" rel="stylesheet" type="text/css"/>
<script type="text/javascript" src="search/searchdata.js"></script>
<script type="text/javascript" src="search/search.js"></script>
<link href="doxygen.css" rel="stylesheet" type="text/css" />
</head>
<body>
<div id="top"><!-- do not remove this div, it is closed by doxygen! -->
<div id="titlearea">
<table cellspacing="0" cellpadding="0">
 <tbody>
 <tr style="height: 56px;">
  <td id="projectalign" style="padding-left: 0.5em;">
   <div id="projectname">eduRayTracer
   &#160;<span id="projectnumber">v_2017_2018_1</span>
   </div>
   <div id="projectbrief">An Educational Ray Tracing Software Package (by Pedro Santana, ISCTE-IUL)</div>
  </td>
 </tr>
 </tbody>
</table>
</div>
<!-- end header part -->
<!-- Generated by Doxygen 1.8.12 -->
<script type="text/javascript">
var searchBox = new SearchBox("searchBox", "search",false,'Search');
</script>
<script type="text/javascript" src="menudata.js"></script>
<script type="text/javascript" src="menu.js"></script>
<script type="text/javascript">
$(function() {
  initMenu('',true,false,'search.php','Search');
  $(document).ready(function() { init_search(); });
});
</script>
<div id="main-nav"></div>
</div><!-- top -->
<div id="side-nav" class="ui-resizable side-nav-resizable">
  <div id="nav-tree">
    <div id="nav-tree-contents">
      <div id="nav-sync" class="sync"></div>
    </div>
  </div>
  <div id="splitbar" style="-moz-user-select:none;" 
       class="ui-resizable-handle">
  </div>
</div>
<script type="text/javascript">
$(document).ready(function(){initNavTree('class_ray_tracer.html','');});
</script>
<div id="doc-content">
<!-- window showing the filter options -->
<div id="MSearchSelectWindow"
     onmouseover="return searchBox.OnSearchSelectShow()"
     onmouseout="return searchBox.OnSearchSelectHide()"
     onkeydown="return searchBox.OnSearchSelectKey(event)">
</div>

<!-- iframe showing the search results (closed by default) -->
<div id="MSearchResultsWindow">
<iframe src="javascript:void(0)" frameborder="0" 
        name="MSearchResults" id="MSearchResults">
</iframe>
</div>

<div class="header">
  <div class="summary">
<a href="#pub-methods">Public Member Functions</a> &#124;
<a href="#pub-attribs">Public Attributes</a> &#124;
<a href="class_ray_tracer-members.html">List of all members</a>  </div>
  <div class="headertitle">
<div class="title">RayTracer Class Reference</div>  </div>
</div><!--header-->
<div class="contents">

<p>A class to create and manipulate surface materials.  
 <a href="class_ray_tracer.html#details">More...</a></p>

<p><code>#include &lt;<a class="el" href="_ray_tracer_8hpp_source.html">RayTracer.hpp</a>&gt;</code></p>
<table class="memberdecls">
<tr class="heading"><td colspan="2"><h2 class="groupheader"><a name="pub-methods"></a>
Public Member Functions</h2></td></tr>
<tr class="memitem:a82688d0457a19e0a96f389ef9b89f729"><td class="memItemLeft" align="right" valign="top">&#160;</td><td class="memItemRight" valign="bottom"><a class="el" href="class_ray_tracer.html#a82688d0457a19e0a96f389ef9b89f729">RayTracer</a> (<a class="el" href="class_camera.html">Camera</a> *_camera, <a class="el" href="class_scene.html">Scene</a> *_scene)</td></tr>
<tr class="memdesc:a82688d0457a19e0a96f389ef9b89f729"><td class="mdescLeft">&#160;</td><td class="mdescRight">A <a class="el" href="class_ray_tracer.html" title="A class to create and manipulate surface materials. ">RayTracer</a> constructor.  <a href="#a82688d0457a19e0a96f389ef9b89f729">More...</a><br /></td></tr>
<tr class="separator:a82688d0457a19e0a96f389ef9b89f729"><td class="memSeparator" colspan="2">&#160;</td></tr>
<tr class="memitem:a5a7a1453c882cf71dc64827e343c1ae4"><td class="memItemLeft" align="right" valign="top">void&#160;</td><td class="memItemRight" valign="bottom"><a class="el" href="class_ray_tracer.html#a5a7a1453c882cf71dc64827e343c1ae4">render</a> ()</td></tr>
<tr class="memdesc:a5a7a1453c882cf71dc64827e343c1ae4"><td class="mdescLeft">&#160;</td><td class="mdescRight">Triggers the rendering process by creating viewing rays and tracing them across the scene by calling <a class="el" href="class_ray_tracer.html#a4239f82baac1501dc9bd5884e2b5eddc" title="Applies the shading equation on the point defined in a given hit record. ">get_shadding()</a>  <a href="#a5a7a1453c882cf71dc64827e343c1ae4">More...</a><br /></td></tr>
<tr class="separator:a5a7a1453c882cf71dc64827e343c1ae4"><td class="memSeparator" colspan="2">&#160;</td></tr>
<tr class="memitem:a529ef735a2c804625b8e4e6208eec9b7"><td class="memItemLeft" align="right" valign="top"><a class="el" href="class_scene.html">Scene</a> *&#160;</td><td class="memItemRight" valign="bottom"><a class="el" href="class_ray_tracer.html#a529ef735a2c804625b8e4e6208eec9b7">getScene</a> ()</td></tr>
<tr class="memdesc:a529ef735a2c804625b8e4e6208eec9b7"><td class="mdescLeft">&#160;</td><td class="mdescRight">Returns a pointer to the <a class="el" href="class_scene.html" title="A class to create and control scenes from Surface and Light objects. ">Scene</a> object.  <a href="#a529ef735a2c804625b8e4e6208eec9b7">More...</a><br /></td></tr>
<tr class="separator:a529ef735a2c804625b8e4e6208eec9b7"><td class="memSeparator" colspan="2">&#160;</td></tr>
<tr class="memitem:a93e5af568fdcc8f5d6a45cead69fe337"><td class="memItemLeft" align="right" valign="top"><a class="el" href="class_camera.html">Camera</a> *&#160;</td><td class="memItemRight" valign="bottom"><a class="el" href="class_ray_tracer.html#a93e5af568fdcc8f5d6a45cead69fe337">getCamera</a> ()</td></tr>
<tr class="memdesc:a93e5af568fdcc8f5d6a45cead69fe337"><td class="mdescLeft">&#160;</td><td class="mdescRight">Returns a pointer to the <a class="el" href="class_camera.html" title="A class to create and manipulate virtual projective cameras. ">Camera</a> object.  <a href="#a93e5af568fdcc8f5d6a45cead69fe337">More...</a><br /></td></tr>
<tr class="separator:a93e5af568fdcc8f5d6a45cead69fe337"><td class="memSeparator" colspan="2">&#160;</td></tr>
<tr class="memitem:ae355f48cf8bd6ee996c204cde4f851dc"><td class="memItemLeft" align="right" valign="top">void&#160;</td><td class="memItemRight" valign="bottom"><a class="el" href="class_ray_tracer.html#ae355f48cf8bd6ee996c204cde4f851dc">setNrAntiAliasingSamples</a> (int _samples)</td></tr>
<tr class="memdesc:ae355f48cf8bd6ee996c204cde4f851dc"><td class="mdescLeft">&#160;</td><td class="mdescRight">Sets the number of samples used for anti-aliasing.  <a href="#ae355f48cf8bd6ee996c204cde4f851dc">More...</a><br /></td></tr>
<tr class="separator:ae355f48cf8bd6ee996c204cde4f851dc"><td class="memSeparator" colspan="2">&#160;</td></tr>
<tr class="memitem:acaf0197e36cd4b7dc85dc42d1fe0b60a"><td class="memItemLeft" align="right" valign="top">void&#160;</td><td class="memItemRight" valign="bottom"><a class="el" href="class_ray_tracer.html#acaf0197e36cd4b7dc85dc42d1fe0b60a">setNrShadowSamples</a> (int _shadow_samples)</td></tr>
<tr class="memdesc:acaf0197e36cd4b7dc85dc42d1fe0b60a"><td class="mdescLeft">&#160;</td><td class="mdescRight">Sets the number of shadow rays for soft shadows.  <a href="#acaf0197e36cd4b7dc85dc42d1fe0b60a">More...</a><br /></td></tr>
<tr class="separator:acaf0197e36cd4b7dc85dc42d1fe0b60a"><td class="memSeparator" colspan="2">&#160;</td></tr>
<tr class="memitem:ac8442d74a14bb488634460d587e5ac48"><td class="memItemLeft" align="right" valign="top">void&#160;</td><td class="memItemRight" valign="bottom"><a class="el" href="class_ray_tracer.html#ac8442d74a14bb488634460d587e5ac48">setDepthRayRecursion</a> (int _hops)</td></tr>
<tr class="memdesc:ac8442d74a14bb488634460d587e5ac48"><td class="mdescLeft">&#160;</td><td class="mdescRight">Sets the number of recursive ray tracing hops (secondary rays).  <a href="#ac8442d74a14bb488634460d587e5ac48">More...</a><br /></td></tr>
<tr class="separator:ac8442d74a14bb488634460d587e5ac48"><td class="memSeparator" colspan="2">&#160;</td></tr>
<tr class="memitem:a51007e02e88d5213dd47284360fcae45"><td class="memItemLeft" align="right" valign="top">int&#160;</td><td class="memItemRight" valign="bottom"><a class="el" href="class_ray_tracer.html#a51007e02e88d5213dd47284360fcae45">get_visible_surface</a> (int i, int j, <a class="el" href="structhit__rec.html">hit_rec</a> &amp;h_r)</td></tr>
<tr class="memdesc:a51007e02e88d5213dd47284360fcae45"><td class="mdescLeft">&#160;</td><td class="mdescRight">Returns the index of the visible <a class="el" href="class_surface.html" title="A base class for every geometry class (e.g., Sphere, Triangle, Mesh). ">Surface</a> object on a given pixel. It does this by finding the closest surface intersected by the ray that passes through the given pixel.  <a href="#a51007e02e88d5213dd47284360fcae45">More...</a><br /></td></tr>
<tr class="separator:a51007e02e88d5213dd47284360fcae45"><td class="memSeparator" colspan="2">&#160;</td></tr>
<tr class="memitem:afb77b881327160bda0aa9dd0bae7a5f5"><td class="memItemLeft" align="right" valign="top">void&#160;</td><td class="memItemRight" valign="bottom"><a class="el" href="class_ray_tracer.html#afb77b881327160bda0aa9dd0bae7a5f5">get_pixel_from_3D</a> (<a class="el" href="class_vec.html">Vec</a> point, <a class="el" href="class_vec.html">Vec</a> &amp;pixel)</td></tr>
<tr class="memdesc:afb77b881327160bda0aa9dd0bae7a5f5"><td class="mdescLeft">&#160;</td><td class="mdescRight">Returns the projection, in pixel coordinates, of a given 3D point.  <a href="#afb77b881327160bda0aa9dd0bae7a5f5">More...</a><br /></td></tr>
<tr class="separator:afb77b881327160bda0aa9dd0bae7a5f5"><td class="memSeparator" colspan="2">&#160;</td></tr>
<tr class="memitem:ada62841980d0982da632d6aa53081538"><td class="memItemLeft" align="right" valign="top"><a class="el" href="class_vec.html">Vec</a>&#160;</td><td class="memItemRight" valign="bottom"><a class="el" href="class_ray_tracer.html#ada62841980d0982da632d6aa53081538">ray_shading</a> (<a class="el" href="class_scene.html">Scene</a> *<a class="el" href="class_ray_tracer.html#ac9cdbb6f2d03e8c1fe9895ac87d64589">scene</a>, <a class="el" href="class_ray.html">Ray</a> &amp;ray, int <a class="el" href="class_ray_tracer.html#a93125040fd72bb71d06678bdcc0bbf08">hops</a>)</td></tr>
<tr class="separator:ada62841980d0982da632d6aa53081538"><td class="memSeparator" colspan="2">&#160;</td></tr>
<tr class="memitem:a4239f82baac1501dc9bd5884e2b5eddc"><td class="memItemLeft" align="right" valign="top"><a class="el" href="class_vec.html">Vec</a>&#160;</td><td class="memItemRight" valign="bottom"><a class="el" href="class_ray_tracer.html#a4239f82baac1501dc9bd5884e2b5eddc">get_shadding</a> (<a class="el" href="structhit__rec.html">hit_rec</a> &amp;h_r, bool bump)</td></tr>
<tr class="memdesc:a4239f82baac1501dc9bd5884e2b5eddc"><td class="mdescLeft">&#160;</td><td class="mdescRight">Applies the shading equation on the point defined in a given hit record.  <a href="#a4239f82baac1501dc9bd5884e2b5eddc">More...</a><br /></td></tr>
<tr class="separator:a4239f82baac1501dc9bd5884e2b5eddc"><td class="memSeparator" colspan="2">&#160;</td></tr>
<tr class="memitem:aaa54f1ee77877741364c27665d4088ab"><td class="memItemLeft" align="right" valign="top"><a class="el" href="class_vec.html">Vec</a>&#160;</td><td class="memItemRight" valign="bottom"><a class="el" href="class_ray_tracer.html#aaa54f1ee77877741364c27665d4088ab">shadow_rays</a> (<a class="el" href="class_scene.html">Scene</a> *<a class="el" href="class_ray_tracer.html#ac9cdbb6f2d03e8c1fe9895ac87d64589">scene</a>, <a class="el" href="structhit__rec.html">hit_rec</a> h_r, <a class="el" href="class_light.html">Light</a> *light, <a class="el" href="class_vec.html">Vec</a> rnd)</td></tr>
<tr class="memdesc:aaa54f1ee77877741364c27665d4088ab"><td class="mdescLeft">&#160;</td><td class="mdescRight">Casts a shadow ray recursively from a given surface point to a <a class="el" href="class_light.html" title="A class to create and manipulate light sources. ">Light</a> source. Returns how much light is attenuated by intersected surfaces.  <a href="#aaa54f1ee77877741364c27665d4088ab">More...</a><br /></td></tr>
<tr class="separator:aaa54f1ee77877741364c27665d4088ab"><td class="memSeparator" colspan="2">&#160;</td></tr>
<tr class="memitem:a8f974dd303bcdb1de773d6fccf3127f0"><td class="memItemLeft" align="right" valign="top">void&#160;</td><td class="memItemRight" valign="bottom"><a class="el" href="class_ray_tracer.html#a8f974dd303bcdb1de773d6fccf3127f0">save_to_file</a> ()</td></tr>
<tr class="memdesc:a8f974dd303bcdb1de773d6fccf3127f0"><td class="mdescLeft">&#160;</td><td class="mdescRight">Saves the last rendering to a .ppm file with a timestamped name.  <a href="#a8f974dd303bcdb1de773d6fccf3127f0">More...</a><br /></td></tr>
<tr class="separator:a8f974dd303bcdb1de773d6fccf3127f0"><td class="memSeparator" colspan="2">&#160;</td></tr>
</table><table class="memberdecls">
<tr class="heading"><td colspan="2"><h2 class="groupheader"><a name="pub-attribs"></a>
Public Attributes</h2></td></tr>
<tr class="memitem:ac9cdbb6f2d03e8c1fe9895ac87d64589"><td class="memItemLeft" align="right" valign="top"><a class="el" href="class_scene.html">Scene</a> *&#160;</td><td class="memItemRight" valign="bottom"><a class="el" href="class_ray_tracer.html#ac9cdbb6f2d03e8c1fe9895ac87d64589">scene</a></td></tr>
<tr class="memdesc:ac9cdbb6f2d03e8c1fe9895ac87d64589"><td class="mdescLeft">&#160;</td><td class="mdescRight">Pointer to the <a class="el" href="class_scene.html" title="A class to create and control scenes from Surface and Light objects. ">Scene</a> to be rendered.  <a href="#ac9cdbb6f2d03e8c1fe9895ac87d64589">More...</a><br /></td></tr>
<tr class="separator:ac9cdbb6f2d03e8c1fe9895ac87d64589"><td class="memSeparator" colspan="2">&#160;</td></tr>
<tr class="memitem:a920e316dba30cabe8f44f61354dcdd83"><td class="memItemLeft" align="right" valign="top"><a class="el" href="class_camera.html">Camera</a> *&#160;</td><td class="memItemRight" valign="bottom"><a class="el" href="class_ray_tracer.html#a920e316dba30cabe8f44f61354dcdd83">camera</a></td></tr>
<tr class="memdesc:a920e316dba30cabe8f44f61354dcdd83"><td class="mdescLeft">&#160;</td><td class="mdescRight">Pointer to the rendering <a class="el" href="class_camera.html" title="A class to create and manipulate virtual projective cameras. ">Camera</a>.  <a href="#a920e316dba30cabe8f44f61354dcdd83">More...</a><br /></td></tr>
<tr class="separator:a920e316dba30cabe8f44f61354dcdd83"><td class="memSeparator" colspan="2">&#160;</td></tr>
<tr class="memitem:addc15de08e27710ac4fd444dec9319b5"><td class="memItemLeft" align="right" valign="top"><a class="el" href="class_vec.html">Vec</a> *&#160;</td><td class="memItemRight" valign="bottom"><a class="el" href="class_ray_tracer.html#addc15de08e27710ac4fd444dec9319b5">image</a></td></tr>
<tr class="memdesc:addc15de08e27710ac4fd444dec9319b5"><td class="mdescLeft">&#160;</td><td class="mdescRight">Floating point rendered image.  <a href="#addc15de08e27710ac4fd444dec9319b5">More...</a><br /></td></tr>
<tr class="separator:addc15de08e27710ac4fd444dec9319b5"><td class="memSeparator" colspan="2">&#160;</td></tr>
<tr class="memitem:a7181bf515b74ec7d8d89b055b48b1d88"><td class="memItemLeft" align="right" valign="top">char *&#160;</td><td class="memItemRight" valign="bottom"><a class="el" href="class_ray_tracer.html#a7181bf515b74ec7d8d89b055b48b1d88">pixels</a></td></tr>
<tr class="memdesc:a7181bf515b74ec7d8d89b055b48b1d88"><td class="mdescLeft">&#160;</td><td class="mdescRight">8-bit rendered image (built from image)  <a href="#a7181bf515b74ec7d8d89b055b48b1d88">More...</a><br /></td></tr>
<tr class="separator:a7181bf515b74ec7d8d89b055b48b1d88"><td class="memSeparator" colspan="2">&#160;</td></tr>
<tr class="memitem:a352f7cb6352afbc395bac32df143982e"><td class="memItemLeft" align="right" valign="top">int&#160;</td><td class="memItemRight" valign="bottom"><a class="el" href="class_ray_tracer.html#a352f7cb6352afbc395bac32df143982e">samples</a></td></tr>
<tr class="memdesc:a352f7cb6352afbc395bac32df143982e"><td class="mdescLeft">&#160;</td><td class="mdescRight">Number of samples used for anti-aliasing.  <a href="#a352f7cb6352afbc395bac32df143982e">More...</a><br /></td></tr>
<tr class="separator:a352f7cb6352afbc395bac32df143982e"><td class="memSeparator" colspan="2">&#160;</td></tr>
<tr class="memitem:aca8693132318560401e7196689f2aaf3"><td class="memItemLeft" align="right" valign="top">int&#160;</td><td class="memItemRight" valign="bottom"><a class="el" href="class_ray_tracer.html#aca8693132318560401e7196689f2aaf3">shadow_samples</a></td></tr>
<tr class="memdesc:aca8693132318560401e7196689f2aaf3"><td class="mdescLeft">&#160;</td><td class="mdescRight">Number of shadow rays for soft shadows.  <a href="#aca8693132318560401e7196689f2aaf3">More...</a><br /></td></tr>
<tr class="separator:aca8693132318560401e7196689f2aaf3"><td class="memSeparator" colspan="2">&#160;</td></tr>
<tr class="memitem:a93125040fd72bb71d06678bdcc0bbf08"><td class="memItemLeft" align="right" valign="top">int&#160;</td><td class="memItemRight" valign="bottom"><a class="el" href="class_ray_tracer.html#a93125040fd72bb71d06678bdcc0bbf08">hops</a></td></tr>
<tr class="memdesc:a93125040fd72bb71d06678bdcc0bbf08"><td class="mdescLeft">&#160;</td><td class="mdescRight">Number of recursive ray tracing hops (secondary rays)  <a href="#a93125040fd72bb71d06678bdcc0bbf08">More...</a><br /></td></tr>
<tr class="separator:a93125040fd72bb71d06678bdcc0bbf08"><td class="memSeparator" colspan="2">&#160;</td></tr>
</table>
<a name="details" id="details"></a><h2 class="groupheader">Detailed Description</h2>
<div class="textblock"><p>A class to create and manipulate surface materials. </p>
</div><h2 class="groupheader">Constructor &amp; Destructor Documentation</h2>
<a id="a82688d0457a19e0a96f389ef9b89f729"></a>
<h2 class="memtitle"><span class="permalink"><a href="#a82688d0457a19e0a96f389ef9b89f729">&sect;&nbsp;</a></span>RayTracer()</h2>

<div class="memitem">
<div class="memproto">
      <table class="memname">
        <tr>
          <td class="memname">RayTracer::RayTracer </td>
          <td>(</td>
          <td class="paramtype"><a class="el" href="class_camera.html">Camera</a> *&#160;</td>
          <td class="paramname"><em>_camera</em>, </td>
        </tr>
        <tr>
          <td class="paramkey"></td>
          <td></td>
          <td class="paramtype"><a class="el" href="class_scene.html">Scene</a> *&#160;</td>
          <td class="paramname"><em>_scene</em>&#160;</td>
        </tr>
        <tr>
          <td></td>
          <td>)</td>
          <td></td><td></td>
        </tr>
      </table>
</div><div class="memdoc">

<p>A <a class="el" href="class_ray_tracer.html" title="A class to create and manipulate surface materials. ">RayTracer</a> constructor. </p>
<dl class="params"><dt>Parameters</dt><dd>
  <table class="params">
    <tr><td class="paramname">_camera</td><td>Pointer to the rendering <a class="el" href="class_camera.html" title="A class to create and manipulate virtual projective cameras. ">Camera</a> </td></tr>
    <tr><td class="paramname">_scene</td><td>Pointer to the <a class="el" href="class_scene.html" title="A class to create and control scenes from Surface and Light objects. ">Scene</a> to be rendered </td></tr>
  </table>
  </dd>
</dl>

</div>
</div>
<h2 class="groupheader">Member Function Documentation</h2>
<a id="afb77b881327160bda0aa9dd0bae7a5f5"></a>
<h2 class="memtitle"><span class="permalink"><a href="#afb77b881327160bda0aa9dd0bae7a5f5">&sect;&nbsp;</a></span>get_pixel_from_3D()</h2>

<div class="memitem">
<div class="memproto">
      <table class="memname">
        <tr>
          <td class="memname">void RayTracer::get_pixel_from_3D </td>
          <td>(</td>
          <td class="paramtype"><a class="el" href="class_vec.html">Vec</a>&#160;</td>
          <td class="paramname"><em>point</em>, </td>
        </tr>
        <tr>
          <td class="paramkey"></td>
          <td></td>
          <td class="paramtype"><a class="el" href="class_vec.html">Vec</a> &amp;&#160;</td>
          <td class="paramname"><em>pixel</em>&#160;</td>
        </tr>
        <tr>
          <td></td>
          <td>)</td>
          <td></td><td></td>
        </tr>
      </table>
</div><div class="memdoc">

<p>Returns the projection, in pixel coordinates, of a given 3D point. </p>
<dl class="params"><dt>Parameters</dt><dd>
  <table class="params">
    <tr><td class="paramname">point</td><td>3D point to be projected </td></tr>
    <tr><td class="paramname">pixel</td><td>Pixel coordinates corresponding to the projection of the 3D point </td></tr>
  </table>
  </dd>
</dl>

</div>
</div>
<a id="a4239f82baac1501dc9bd5884e2b5eddc"></a>
<h2 class="memtitle"><span class="permalink"><a href="#a4239f82baac1501dc9bd5884e2b5eddc">&sect;&nbsp;</a></span>get_shadding()</h2>

<div class="memitem">
<div class="memproto">
      <table class="memname">
        <tr>
          <td class="memname"><a class="el" href="class_vec.html">Vec</a> RayTracer::get_shadding </td>
          <td>(</td>
          <td class="paramtype"><a class="el" href="structhit__rec.html">hit_rec</a> &amp;&#160;</td>
          <td class="paramname"><em>h_r</em>, </td>
        </tr>
        <tr>
          <td class="paramkey"></td>
          <td></td>
          <td class="paramtype">bool&#160;</td>
          <td class="paramname"><em>bump</em>&#160;</td>
        </tr>
        <tr>
          <td></td>
          <td>)</td>
          <td></td><td></td>
        </tr>
      </table>
</div><div class="memdoc">

<p>Applies the shading equation on the point defined in a given hit record. </p>
<dl class="params"><dt>Parameters</dt><dd>
  <table class="params">
    <tr><td class="paramname">h_r</td><td>Hit record that provides the information regarding the point and its supporting surface to shade </td></tr>
    <tr><td class="paramname">bump</td><td>Flag stating if bump mapping is to be considered in the shadding equation </td></tr>
  </table>
  </dd>
</dl>
<dl class="section return"><dt>Returns</dt><dd>RGB vector resulting from applying the shading equation </dd></dl>

</div>
</div>
<a id="a51007e02e88d5213dd47284360fcae45"></a>
<h2 class="memtitle"><span class="permalink"><a href="#a51007e02e88d5213dd47284360fcae45">&sect;&nbsp;</a></span>get_visible_surface()</h2>

<div class="memitem">
<div class="memproto">
      <table class="memname">
        <tr>
          <td class="memname">int RayTracer::get_visible_surface </td>
          <td>(</td>
          <td class="paramtype">int&#160;</td>
          <td class="paramname"><em>i</em>, </td>
        </tr>
        <tr>
          <td class="paramkey"></td>
          <td></td>
          <td class="paramtype">int&#160;</td>
          <td class="paramname"><em>j</em>, </td>
        </tr>
        <tr>
          <td class="paramkey"></td>
          <td></td>
          <td class="paramtype"><a class="el" href="structhit__rec.html">hit_rec</a> &amp;&#160;</td>
          <td class="paramname"><em>h_r</em>&#160;</td>
        </tr>
        <tr>
          <td></td>
          <td>)</td>
          <td></td><td></td>
        </tr>
      </table>
</div><div class="memdoc">

<p>Returns the index of the visible <a class="el" href="class_surface.html" title="A base class for every geometry class (e.g., Sphere, Triangle, Mesh). ">Surface</a> object on a given pixel. It does this by finding the closest surface intersected by the ray that passes through the given pixel. </p>
<dl class="params"><dt>Parameters</dt><dd>
  <table class="params">
    <tr><td class="paramname">i</td><td>Pixel coordinate </td></tr>
    <tr><td class="paramname">j</td><td>Pixel coordinate </td></tr>
    <tr><td class="paramname">h_r</td><td>Hit record that will be filled with the information regarding the visible surface </td></tr>
  </table>
  </dd>
</dl>
<dl class="section return"><dt>Returns</dt><dd>Index of the visible surface on the surfaces vector stored in the object <a class="el" href="class_scene.html" title="A class to create and control scenes from Surface and Light objects. ">Scene</a> (scene.surfaces) </dd></dl>

</div>
</div>
<a id="a93e5af568fdcc8f5d6a45cead69fe337"></a>
<h2 class="memtitle"><span class="permalink"><a href="#a93e5af568fdcc8f5d6a45cead69fe337">&sect;&nbsp;</a></span>getCamera()</h2>

<div class="memitem">
<div class="memproto">
<table class="mlabels">
  <tr>
  <td class="mlabels-left">
      <table class="memname">
        <tr>
          <td class="memname"><a class="el" href="class_camera.html">Camera</a>* RayTracer::getCamera </td>
          <td>(</td>
          <td class="paramname"></td><td>)</td>
          <td></td>
        </tr>
      </table>
  </td>
  <td class="mlabels-right">
<span class="mlabels"><span class="mlabel">inline</span></span>  </td>
  </tr>
</table>
</div><div class="memdoc">

<p>Returns a pointer to the <a class="el" href="class_camera.html" title="A class to create and manipulate virtual projective cameras. ">Camera</a> object. </p>
<dl class="section return"><dt>Returns</dt><dd>A pointer to the <a class="el" href="class_scene.html" title="A class to create and control scenes from Surface and Light objects. ">Scene</a> object. </dd></dl>

</div>
</div>
<a id="a529ef735a2c804625b8e4e6208eec9b7"></a>
<h2 class="memtitle"><span class="permalink"><a href="#a529ef735a2c804625b8e4e6208eec9b7">&sect;&nbsp;</a></span>getScene()</h2>

<div class="memitem">
<div class="memproto">
<table class="mlabels">
  <tr>
  <td class="mlabels-left">
      <table class="memname">
        <tr>
          <td class="memname"><a class="el" href="class_scene.html">Scene</a>* RayTracer::getScene </td>
          <td>(</td>
          <td class="paramname"></td><td>)</td>
          <td></td>
        </tr>
      </table>
  </td>
  <td class="mlabels-right">
<span class="mlabels"><span class="mlabel">inline</span></span>  </td>
  </tr>
</table>
</div><div class="memdoc">

<p>Returns a pointer to the <a class="el" href="class_scene.html" title="A class to create and control scenes from Surface and Light objects. ">Scene</a> object. </p>
<dl class="section return"><dt>Returns</dt><dd>A pointer to the <a class="el" href="class_scene.html" title="A class to create and control scenes from Surface and Light objects. ">Scene</a> object. </dd></dl>

</div>
</div>
<a id="ada62841980d0982da632d6aa53081538"></a>
<h2 class="memtitle"><span class="permalink"><a href="#ada62841980d0982da632d6aa53081538">&sect;&nbsp;</a></span>ray_shading()</h2>

<div class="memitem">
<div class="memproto">
      <table class="memname">
        <tr>
          <td class="memname"><a class="el" href="class_vec.html">Vec</a> RayTracer::ray_shading </td>
          <td>(</td>
          <td class="paramtype"><a class="el" href="class_scene.html">Scene</a> *&#160;</td>
          <td class="paramname"><em>scene</em>, </td>
        </tr>
        <tr>
          <td class="paramkey"></td>
          <td></td>
          <td class="paramtype"><a class="el" href="class_ray.html">Ray</a> &amp;&#160;</td>
          <td class="paramname"><em>ray</em>, </td>
        </tr>
        <tr>
          <td class="paramkey"></td>
          <td></td>
          <td class="paramtype">int&#160;</td>
          <td class="paramname"><em>hops</em>&#160;</td>
        </tr>
        <tr>
          <td></td>
          <td>)</td>
          <td></td><td></td>
        </tr>
      </table>
</div><div class="memdoc">
<p>Recursively traces the scene from a given <a class="el" href="class_ray.html" title="A class to create and manipulate 3D rays. ">Ray</a> (when called from <a class="el" href="class_ray_tracer.html#a5a7a1453c882cf71dc64827e343c1ae4" title="Triggers the rendering process by creating viewing rays and tracing them across the scene by calling ...">render()</a> it is a viewing/primary ray, later on it may be a reflection, refraction or shadow secondary ray). When needed, the shading equation is computed by calling <a class="el" href="class_ray_tracer.html#a4239f82baac1501dc9bd5884e2b5eddc" title="Applies the shading equation on the point defined in a given hit record. ">get_shadding()</a></p>
<dl class="params"><dt>Parameters</dt><dd>
  <table class="params">
    <tr><td class="paramname">_scene</td><td>Pointer to the <a class="el" href="class_scene.html" title="A class to create and control scenes from Surface and Light objects. ">Scene</a> to be rendered (it contains all geometry for the intersection tests) </td></tr>
    <tr><td class="paramname">r</td><td><a class="el" href="class_ray.html" title="A class to create and manipulate 3D rays. ">Ray</a> to be traced recursively </td></tr>
    <tr><td class="paramname">hops</td><td>Maximum number of hops (recursion steps) still available (this number is recursively decreased whenever an intersection is observed and a secondary ray casted) </td></tr>
  </table>
  </dd>
</dl>
<dl class="section return"><dt>Returns</dt><dd>RGB vector resulting from applying integrating the shading equation along the recursive tracing process </dd></dl>

</div>
</div>
<a id="a5a7a1453c882cf71dc64827e343c1ae4"></a>
<h2 class="memtitle"><span class="permalink"><a href="#a5a7a1453c882cf71dc64827e343c1ae4">&sect;&nbsp;</a></span>render()</h2>

<div class="memitem">
<div class="memproto">
      <table class="memname">
        <tr>
          <td class="memname">void RayTracer::render </td>
          <td>(</td>
          <td class="paramname"></td><td>)</td>
          <td></td>
        </tr>
      </table>
</div><div class="memdoc">

<p>Triggers the rendering process by creating viewing rays and tracing them across the scene by calling <a class="el" href="class_ray_tracer.html#a4239f82baac1501dc9bd5884e2b5eddc" title="Applies the shading equation on the point defined in a given hit record. ">get_shadding()</a> </p>

</div>
</div>
<a id="a8f974dd303bcdb1de773d6fccf3127f0"></a>
<h2 class="memtitle"><span class="permalink"><a href="#a8f974dd303bcdb1de773d6fccf3127f0">&sect;&nbsp;</a></span>save_to_file()</h2>

<div class="memitem">
<div class="memproto">
      <table class="memname">
        <tr>
          <td class="memname">void RayTracer::save_to_file </td>
          <td>(</td>
          <td class="paramname"></td><td>)</td>
          <td></td>
        </tr>
      </table>
</div><div class="memdoc">

<p>Saves the last rendering to a .ppm file with a timestamped name. </p>

</div>
</div>
<a id="ac8442d74a14bb488634460d587e5ac48"></a>
<h2 class="memtitle"><span class="permalink"><a href="#ac8442d74a14bb488634460d587e5ac48">&sect;&nbsp;</a></span>setDepthRayRecursion()</h2>

<div class="memitem">
<div class="memproto">
<table class="mlabels">
  <tr>
  <td class="mlabels-left">
      <table class="memname">
        <tr>
          <td class="memname">void RayTracer::setDepthRayRecursion </td>
          <td>(</td>
          <td class="paramtype">int&#160;</td>
          <td class="paramname"><em>_hops</em></td><td>)</td>
          <td></td>
        </tr>
      </table>
  </td>
  <td class="mlabels-right">
<span class="mlabels"><span class="mlabel">inline</span></span>  </td>
  </tr>
</table>
</div><div class="memdoc">

<p>Sets the number of recursive ray tracing hops (secondary rays). </p>
<dl class="params"><dt>Parameters</dt><dd>
  <table class="params">
    <tr><td class="paramname">_hops</td><td>The number of recursive ray tracing hops (secondary rays). </td></tr>
  </table>
  </dd>
</dl>

</div>
</div>
<a id="ae355f48cf8bd6ee996c204cde4f851dc"></a>
<h2 class="memtitle"><span class="permalink"><a href="#ae355f48cf8bd6ee996c204cde4f851dc">&sect;&nbsp;</a></span>setNrAntiAliasingSamples()</h2>

<div class="memitem">
<div class="memproto">
<table class="mlabels">
  <tr>
  <td class="mlabels-left">
      <table class="memname">
        <tr>
          <td class="memname">void RayTracer::setNrAntiAliasingSamples </td>
          <td>(</td>
          <td class="paramtype">int&#160;</td>
          <td class="paramname"><em>_samples</em></td><td>)</td>
          <td></td>
        </tr>
      </table>
  </td>
  <td class="mlabels-right">
<span class="mlabels"><span class="mlabel">inline</span></span>  </td>
  </tr>
</table>
</div><div class="memdoc">

<p>Sets the number of samples used for anti-aliasing. </p>
<dl class="params"><dt>Parameters</dt><dd>
  <table class="params">
    <tr><td class="paramname">_samples</td><td>The number of samples used for anti-aliasing. </td></tr>
  </table>
  </dd>
</dl>

</div>
</div>
<a id="acaf0197e36cd4b7dc85dc42d1fe0b60a"></a>
<h2 class="memtitle"><span class="permalink"><a href="#acaf0197e36cd4b7dc85dc42d1fe0b60a">&sect;&nbsp;</a></span>setNrShadowSamples()</h2>

<div class="memitem">
<div class="memproto">
<table class="mlabels">
  <tr>
  <td class="mlabels-left">
      <table class="memname">
        <tr>
          <td class="memname">void RayTracer::setNrShadowSamples </td>
          <td>(</td>
          <td class="paramtype">int&#160;</td>
          <td class="paramname"><em>_shadow_samples</em></td><td>)</td>
          <td></td>
        </tr>
      </table>
  </td>
  <td class="mlabels-right">
<span class="mlabels"><span class="mlabel">inline</span></span>  </td>
  </tr>
</table>
</div><div class="memdoc">

<p>Sets the number of shadow rays for soft shadows. </p>
<dl class="params"><dt>Parameters</dt><dd>
  <table class="params">
    <tr><td class="paramname">_shadow_samples</td><td>The number of shadow rays for soft shadows. </td></tr>
  </table>
  </dd>
</dl>

</div>
</div>
<a id="aaa54f1ee77877741364c27665d4088ab"></a>
<h2 class="memtitle"><span class="permalink"><a href="#aaa54f1ee77877741364c27665d4088ab">&sect;&nbsp;</a></span>shadow_rays()</h2>

<div class="memitem">
<div class="memproto">
      <table class="memname">
        <tr>
          <td class="memname"><a class="el" href="class_vec.html">Vec</a> RayTracer::shadow_rays </td>
          <td>(</td>
          <td class="paramtype"><a class="el" href="class_scene.html">Scene</a> *&#160;</td>
          <td class="paramname"><em>scene</em>, </td>
        </tr>
        <tr>
          <td class="paramkey"></td>
          <td></td>
          <td class="paramtype"><a class="el" href="structhit__rec.html">hit_rec</a>&#160;</td>
          <td class="paramname"><em>h_r</em>, </td>
        </tr>
        <tr>
          <td class="paramkey"></td>
          <td></td>
          <td class="paramtype"><a class="el" href="class_light.html">Light</a> *&#160;</td>
          <td class="paramname"><em>light</em>, </td>
        </tr>
        <tr>
          <td class="paramkey"></td>
          <td></td>
          <td class="paramtype"><a class="el" href="class_vec.html">Vec</a>&#160;</td>
          <td class="paramname"><em>rnd</em>&#160;</td>
        </tr>
        <tr>
          <td></td>
          <td>)</td>
          <td></td><td></td>
        </tr>
      </table>
</div><div class="memdoc">

<p>Casts a shadow ray recursively from a given surface point to a <a class="el" href="class_light.html" title="A class to create and manipulate light sources. ">Light</a> source. Returns how much light is attenuated by intersected surfaces. </p>
<dl class="params"><dt>Parameters</dt><dd>
  <table class="params">
    <tr><td class="paramname">_scene</td><td>Pointer to the <a class="el" href="class_scene.html" title="A class to create and control scenes from Surface and Light objects. ">Scene</a> to be rendered </td></tr>
    <tr><td class="paramname">h_r</td><td>Hit record holding information regarding the point to be shadowed </td></tr>
    <tr><td class="paramname">light</td><td>Pointer to the <a class="el" href="class_light.html" title="A class to create and manipulate light sources. ">Light</a> source </td></tr>
    <tr><td class="paramname">rnd</td><td>Randomised vector to be used when casting the shadow ray </td></tr>
  </table>
  </dd>
</dl>
<dl class="section return"><dt>Returns</dt><dd>How much light is attenuated by intersected surfaces </dd></dl>

</div>
</div>
<h2 class="groupheader">Member Data Documentation</h2>
<a id="a920e316dba30cabe8f44f61354dcdd83"></a>
<h2 class="memtitle"><span class="permalink"><a href="#a920e316dba30cabe8f44f61354dcdd83">&sect;&nbsp;</a></span>camera</h2>

<div class="memitem">
<div class="memproto">
      <table class="memname">
        <tr>
          <td class="memname"><a class="el" href="class_camera.html">Camera</a>* RayTracer::camera</td>
        </tr>
      </table>
</div><div class="memdoc">

<p>Pointer to the rendering <a class="el" href="class_camera.html" title="A class to create and manipulate virtual projective cameras. ">Camera</a>. </p>

</div>
</div>
<a id="a93125040fd72bb71d06678bdcc0bbf08"></a>
<h2 class="memtitle"><span class="permalink"><a href="#a93125040fd72bb71d06678bdcc0bbf08">&sect;&nbsp;</a></span>hops</h2>

<div class="memitem">
<div class="memproto">
      <table class="memname">
        <tr>
          <td class="memname">int RayTracer::hops</td>
        </tr>
      </table>
</div><div class="memdoc">

<p>Number of recursive ray tracing hops (secondary rays) </p>

</div>
</div>
<a id="addc15de08e27710ac4fd444dec9319b5"></a>
<h2 class="memtitle"><span class="permalink"><a href="#addc15de08e27710ac4fd444dec9319b5">&sect;&nbsp;</a></span>image</h2>

<div class="memitem">
<div class="memproto">
      <table class="memname">
        <tr>
          <td class="memname"><a class="el" href="class_vec.html">Vec</a>* RayTracer::image</td>
        </tr>
      </table>
</div><div class="memdoc">

<p>Floating point rendered image. </p>

</div>
</div>
<a id="a7181bf515b74ec7d8d89b055b48b1d88"></a>
<h2 class="memtitle"><span class="permalink"><a href="#a7181bf515b74ec7d8d89b055b48b1d88">&sect;&nbsp;</a></span>pixels</h2>

<div class="memitem">
<div class="memproto">
      <table class="memname">
        <tr>
          <td class="memname">char* RayTracer::pixels</td>
        </tr>
      </table>
</div><div class="memdoc">

<p>8-bit rendered image (built from image) </p>

</div>
</div>
<a id="a352f7cb6352afbc395bac32df143982e"></a>
<h2 class="memtitle"><span class="permalink"><a href="#a352f7cb6352afbc395bac32df143982e">&sect;&nbsp;</a></span>samples</h2>

<div class="memitem">
<div class="memproto">
      <table class="memname">
        <tr>
          <td class="memname">int RayTracer::samples</td>
        </tr>
      </table>
</div><div class="memdoc">

<p>Number of samples used for anti-aliasing. </p>

</div>
</div>
<a id="ac9cdbb6f2d03e8c1fe9895ac87d64589"></a>
<h2 class="memtitle"><span class="permalink"><a href="#ac9cdbb6f2d03e8c1fe9895ac87d64589">&sect;&nbsp;</a></span>scene</h2>

<div class="memitem">
<div class="memproto">
      <table class="memname">
        <tr>
          <td class="memname"><a class="el" href="class_scene.html">Scene</a>* RayTracer::scene</td>
        </tr>
      </table>
</div><div class="memdoc">

<p>Pointer to the <a class="el" href="class_scene.html" title="A class to create and control scenes from Surface and Light objects. ">Scene</a> to be rendered. </p>

</div>
</div>
<a id="aca8693132318560401e7196689f2aaf3"></a>
<h2 class="memtitle"><span class="permalink"><a href="#aca8693132318560401e7196689f2aaf3">&sect;&nbsp;</a></span>shadow_samples</h2>

<div class="memitem">
<div class="memproto">
      <table class="memname">
        <tr>
          <td class="memname">int RayTracer::shadow_samples</td>
        </tr>
      </table>
</div><div class="memdoc">

<p>Number of shadow rays for soft shadows. </p>

</div>
</div>
<hr/>The documentation for this class was generated from the following files:<ul>
<li>src/<a class="el" href="_ray_tracer_8hpp_source.html">RayTracer.hpp</a></li>
<li>src/<a class="el" href="_ray_tracer_8cpp.html">RayTracer.cpp</a></li>
</ul>
</div><!-- contents -->
</div><!-- doc-content -->
<!-- start footer part -->
<div id="nav-path" class="navpath"><!-- id is needed for treeview function! -->
  <ul>
    <li class="navelem"><a class="el" href="class_ray_tracer.html">RayTracer</a></li>
    <li class="footer">Generated on Fri Sep 15 2017 15:54:23 for eduRayTracer by
    <a href="http://www.doxygen.org/index.html">
    <img class="footer" src="doxygen.png" alt="doxygen"/></a> 1.8.12 </li>
  </ul>
</div>
</body>
</html>
